<?
/**
 * Fix {}
 * %t - tables list
 */

function db_connect($set) {

  if (!$conn = mysql_connect($set['server'], $set['username'], $set['password'], TRUE)) {
    return FALSE;
  }

  if (!mysql_select_db($set['db'], $conn)) {
    return FALSE;
  }
  
  mysql_query('SET NAMES utf8', $conn);
  return $conn;
}


/**
 * Определяем ошибку
 */
function db_error() {
  global $db_active;
  return mysql_error();
}

/**
 * Helper function for db_query()
 */
function _db_query($query, $unbuffered) {
  global $db_active;
  $query_type = strtoupper(substr(trim($query),0,6));

  // unbuffered - you can start working on the result set immediately after the first row 
  // has been retrieved: you don't have to wait until the complete SQL query has been performed.
  // Но нельзя послать такой запрос: foreach ($row = mysql_fetch_row()) query based on $row data
  $result = $unbuffered ? mysql_unbuffered_query($query, $db_active) : mysql_query($query, $db_active);

  if (db_error()) {
    trigger_error($query);
  }

  if ($result) {
    switch ($query_type) {
      case 'SELECT':
      case '(SELEC':
        return $result;
      case 'INSERT':
        return mysql_insert_id($db_active);
      default:
        return mysql_affected_rows($db_active);
    }
  }
  else {
    return NULL;
  }
}

/**
 * Количество записей
 */
function db_num_rows($result) {
  return mysql_num_rows($result);
}

/**
 * Получаем значение
 */
function db_fetch_array($result, $type = MYSQL_ASSOC) {
  $res = mysql_fetch_array($result, $type);
  return $res ? $res : NULL;
}

function db_fetch($result) {
  $res = db_fetch_array($result, MYSQL_NUM);
  return $res ? $res : NULL;
}

/**
 * Получение отдельной записи
 */
function db_result($result, $index = 0) {
  $row = mysql_fetch_row($result);
  mysql_free_result($result);
  return $row ? $row[$index] : NULL;
}

/**
 * Список, возможно возвращение поля по ключу
 */
function db_list($result, $key = FALSE, $delete_key = FALSE) {
  $ret = array();
  while ($r = db_fetch_array($result)) {
    if ($key) {
      $k = $r[$key];
      if ($delete_key) {
        unset($r[$key]);
      }
      $ret[$k] = $r;
    }
    else {
      $ret[] = $r;
    }
  }
  mysql_free_result($result);
  return $ret ? $ret : NULL;
}

/**
 * Список значений одного поля
 */
function db_rows($result) {
  $retval = array();
  while ($r = db_fetch($result)) {
    $retval[] = $r[0];
  }
  mysql_free_result($result);
  return $retval ? $retval : NULL;
}

/**
 *
 */
function db_hash($result, $name, $value) {
  $ret = array();
  while ($r = mysql_fetch_array($result, MYSQL_ASSOC)) {  
    $n = $r[$name];
    $v = $r[$value];     
    $ret[$n] = $v;
  }
  mysql_free_result($result);
  return $ret ? $ret : NULL;
}


/**
 * Затронуто
 */
function db_affected_rows() {
  global $db_active;
  return mysql_affected_rows($db_active);
}

/**
 * Экранируем
 */
function db_escape_string($text) {
  global $db_active;
  return "'". mysql_real_escape_string($text, $db_active) ."'";
}

/**
 * Проверка на существование таблицы
 */
function db_table_exists($table) {
  return db_num_rows(db_query("SHOW TABLES LIKE '$table'"));
}

function db_close() {
  global $db_active;
  mysql_close($db_active);
}

function db_free_result($result) {
  return mysql_free_result($result);
}


function db_is_active() {
  global $db_active;
  return is_resource($db_active);
}

function db_set_active($name = 'primary') {
  global $db_active;
  // хранимые соединения
  static $db_conns;

  if (!isset($db_conns[$name])) {

    if (!$c = db_connect(block_get('db_' . $name))) {
      header_unavailable();
      trigger_error('db connection failed');
      die('На сервере ведутся технические работы. В ближайшее время сервер вернется к жизни.');

      exit;
    }

  $db_conns[$name] = $c;
  }

  // сохраняем имя предыдущего соединения
  $db_previous = $db_active;
  // делаем активным новое соединение
  $db_active = $db_conns[$name];

  // возвращаем ключ (название) последнего соединения (для его последующего восстановления)
  return array_search($db_previous, $db_conns);
}

/**
 * Функция отправки запроса. Пользуется вспомогательными функциями в подключенных файлах
 * получает запрос вида db_query('SELECT * FROM table WHERE id = %d, string = %s, float = %f', 15, 'str', 15.2);
 * чтобы выключить unbuffered_query: db_query(FALSE, 'SELECT * ... ', 'params');
 */
function db_query() {
  if (!db_is_active()) {
    db_set_active();
  }
  
  // данные для подстановки в запрос
  $args = func_get_args();

  $unbuffered = FALSE;

  // нужно вычленить query и flag of unbuffered (если есть)
  $query = array_shift($args);
  if (is_bool($query)) {
    $unbuffered = $query;
    $query = array_shift($args);
  }


  // заносим в функцию данные (инициализируем), чтобы не использовать глобальные
  // переменные, или сложную конструкцию в preg_replace
  _db_query_callback($args, TRUE);
  // подставляем вместо % значения, найденные результаты по порядку отправляются в
  // callback функцию, а там выбираются из посланных ранее аргументов в зависимости от знака после %
  $query = preg_replace_callback('/(%d|%s|%%|%f|%l|%t)/', '_db_query_callback', $query);
  
  // подставляем вместо {table} таблицу с нужным префиксом prefix_table
  if ($prefix = block_get('db_prefix')) {
    $query = preg_replace('/\{([-a-zA-Z0-9_]*?)\}/', $prefix . '$1', $query);
  }

  // отлаживаем запросы
  if ($db_debug = block_get('db_debug', FALSE)) {
    timer_start('db_debug');
  }

  $result = _db_query($query, $unbuffered);

  if ($db_debug) {
    echo '<p>query: '. $query
        .  '<br />rows: ' . db_num_rows($result) 
        .  '<br />error: ' . db_error()
        .  '<br />time: '. timer_read('db_debug') 
        .  '</p>';
  }

  if ($error = db_error()) {
    trigger_error($error, E_USER_WARNING);
  }

  return $result;
}

function _db_query_callback($match, $init = FALSE) {
  static $args = NULL;
  if ($init) {
    $args = $match;
    return;
  }

  switch ($match[1]) {
    case '%d':
      return (int) array_shift($args);
    case '%s':
      return db_escape_string(strval(array_shift($args)));
    case '%%':
      return '%';
    case '%f':
      return db_escape_string(strtr(floatval(array_shift($args)), ',', '.'));
    case '%l': 
      return implode(',', array_map('db_escape_string', array_shift($args)));
    case '%t':
      return '`' . implode('`,`', array_shift($args)) . '`';
  }
}
